#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_view;
	mat4 m_model;
	mat3 m_normal;
	mat4 m_shadow;		// From world space to the texture coordinate space
};

in vec4 position;	// local space
in vec3 normal;		// local space

out Data
{
	vec3 normal;
	vec4 eye;
	vec4 shadowCoord;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 6) Transform vertex according to the comments.
//----------------------------------------------------------------

void main()
{
	// TODO 6: Transform the vertex from the object space into the world space (hint: use m_model)
	vec4 vertex = m_model * position;

	// TODO 6: Transform the vertex from world space to shadow texture space (hint: use m_shadow), save it into shadowCoord
	DataOut.shadowCoord = m_shadow * vertex;

	// Compute vector to camera in camera space
	DataOut.eye = -(m_view * m_model * position);

	// Compute view space normal
	DataOut.normal = normalize(m_normal * normal);

	// Transform to projection / clip space, save into gl_Position
	gl_Position = m_pvm * position;
}